unit GraphicUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TGraphicForm = class(TForm)
    Panel1: TPanel;
    CancelButton: TButton;
    SaveButton: TButton;
    ImportButton: TButton;
    OpenDialog: TOpenDialog;
    ScrollBox1: TScrollBox;
    Image: TImage;
    ExportButton: TButton;
    SaveDialog: TSaveDialog;
    procedure ImportButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ExportButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Modified: boolean;
  end;

var
  GraphicForm: TGraphicForm;

implementation

{$R *.DFM}
  

procedure TGraphicForm.ImportButtonClick(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    Image.AutoSize:=true;
    Image.Picture.LoadFromFile(OpenDialog.FileName);
    Modified:=true;
  end;
end;

procedure TGraphicForm.FormCreate(Sender: TObject);
begin
  Modified:=false;
end;


procedure TGraphicForm.ExportButtonClick(Sender: TObject);
begin
  SaveDialog.DefaultExt:=GraphicExtension(TGraphicClass(Image.Picture.Graphic.ClassType));
  if SaveDialog.Execute then
  begin
    Image.Picture.SaveToFile(SaveDialog.FileName);
    Modified:=true;
  end;
end;

end.
